"""
Tests for carta_envoy.carta
"""
import argparse
from pathlib import Path
from unittest.mock import patch

import carta_envoy.carta as carta

expected_settings = {
    "timeout": "1",
    "carta_path": "/fake/path/to/nowhere",
    "redis_host": "noplace.nrao.edu",
    "redis_port": "6397",
    "redis_password": "password",
    "reverse_proxy": "black-abyss.nrao.edu",
    "data_location": Path("/fake/location/path"),
    "useCarta": "False",
    "notification_url": "http://notification:3458",
    "workflow_url": "http://workflow:3456",
}

location = "/fake/location/path"


class TestCarta:
    def test_get_settings(self):
        settings = carta._get_settings(location)
        # assert settings["timeout"] == expected_settings["timeout"]
        # assert settings["carta_path"] == expected_settings["carta_path"]
        # assert settings["redis_host"] == expected_settings["redis_host"]
        # assert settings["redis_port"] == expected_settings["redis_port"]
        # assert settings["redis_password"] == expected_settings["redis_password"]
        # assert settings["reverse_proxy"] == expected_settings["reverse_proxy"]
        # assert settings["data_location"] == expected_settings["data_location"]
        # assert settings["useCarta"] == expected_settings["useCarta"]

        for key in settings.keys():
            assert settings[key] == expected_settings[key]

    @patch("os.chdir")
    @patch("glob.glob")
    def test_ensure_correct_directory(self, mock_glob, mock_chdir):
        carta.ensure_correct_directory(settings=expected_settings)
        assert mock_glob.call_count == 2

    def test_make_arg_parser(self):
        assert isinstance(carta.make_arg_parser(), argparse.ArgumentParser)
